/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui.haptics.forces_panels;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.ListModel;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.InputFields;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.RegularFld_DA;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui.JListClickHelper;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.haptic_forces.forces.IForce;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.haptic_forces.forces.VectorFieldForce;

/**
 *
 * @author Krzysztof Madejski <krzysztof@madejscy.pl> ICM, University of Warsaw
 * @author modified by Łukasz Czerwiński <czerwinskilukasz1 [#] gmail.com>, ICM, University of
 * Warsaw, 2013
 */
public class EditVectorFieldPanel extends AbstractEditPanel
{

    private VectorFieldForce vectorField;
    private InputFields fields;

    public EditVectorFieldPanel(VectorFieldForce vectorField, InputFields fields)
    {
        this.fields = fields;

        initComponents();

        this.vectorField = vectorField;
        dataCB.setSelectedIndex(vectorField.getDataComponentIndex());

        forceScaleTF.setText("" + vectorField.getForceScale());

        /* mouse listener - user can click twice on name of the force instead of selecting it 
         * and clicking Add */
        dataCB.addMouseListener(new MouseAdapter()
        {
            @Override
            public void mouseClicked(MouseEvent evt)
            {

                if (evt.getButton() == MouseEvent.BUTTON1 &&
                    evt.getClickCount() == 2) { // left double click - go Next

                    JList list = (JList) evt.getSource();

                    int index = JListClickHelper.getClickedLocation(list, evt.getPoint()); //could not be locationToIndex(evt.getPoint()), see comment in getClickedLocation
                    if (index >= 0) {
                        list.setSelectedIndex(index);
                        _okButtonActionPerformed();
                    }
                }
            }
        });
    }

    //    private ComboBoxModel createDataComboModel() {
    private ListModel createDataComboModel()
    {
        //        ListModel model = new DefaultListModel();//(fields.getVectorFields().toArray());
        //        new ArrayLi
        return new DefaultComboBoxModel(fields.getVectorFields().toArray());
    }

    @Override
    public IForce getForce()
    {
        return vectorField;
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel2 = new javax.swing.JLabel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jScrollPane = new javax.swing.JScrollPane();
        dataCB = new javax.swing.JList();
        jLabel3 = new javax.swing.JLabel();
        forceScaleTF = new javax.swing.JTextField();

        setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Data component:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.ipady = 177;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(11, 10, 0, 0);
        add(jLabel2, gridBagConstraints);

        okButton.setText("OK");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.ipadx = 36;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(6, 10, 11, 0);
        add(okButton, gridBagConstraints);

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.ipadx = 34;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(6, 6, 11, 0);
        add(cancelButton, gridBagConstraints);

        dataCB.setModel(createDataComboModel());
        jScrollPane.setViewportView(dataCB);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 232;
        gridBagConstraints.ipady = 168;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(11, 6, 0, 10);
        add(jScrollPane, gridBagConstraints);

        jLabel3.setText("Force scale:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(9, 20, 0, 0);
        add(jLabel3, gridBagConstraints);

        forceScaleTF.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                forceScaleTFaddButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.ipadx = 249;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(6, 6, 0, 10);
        add(forceScaleTF, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * NOTE: use
     * <code>_cancelButtonActionPerformed()</code> instead.
     * <p/>
     * @param evt
     */
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // please, DO NOT add any lines here, instead edit _cancelButtonActionPerformed()
        // a workaround, because Netbeans doesn't allow changing visibility of action handler :/
        _cancelButtonActionPerformed();
    }//GEN-LAST:event_cancelButtonActionPerformed

    /**
     * NOTE: "_" in name is used as a workaround to a Netbeans bug that doesn't allow to use change
     * modifier from private.
     */
    @Override
    protected void _cancelButtonActionPerformed()
    {
        vectorField = null;
        setVisible(false);
    }

    /**
     * Use
     * <code>_okButtonActionPerformed()</code> instead.
     * <p/>
     * @param evt
     */
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // please, DO NOT add any lines here, instead edit _okButtonActionPerformed()
        // it's a workaround, because Netbeans doesn't allow changing visibility of action handler :/
        _okButtonActionPerformed();
    }

    /**
     * NOTE: "_" in name is used as a workaround to a Netbeans bug that doesn't allow to use change
     * modifier from private.
     */
    @Override
    protected void _okButtonActionPerformed()
    {
        RegularFld_DA data = (RegularFld_DA) dataCB.getSelectedValue();
        if (data == null) {
            JOptionPane.showMessageDialog(this, "Please select a component from the list.", "No data was selected", JOptionPane.INFORMATION_MESSAGE);
        } else {
            try {
                float forceScale = Float.parseFloat(forceScaleTF.getText());

                if (forceScale < 0)
                    throw new NegativeScaleException();

                vectorField.setData(dataCB.getSelectedIndex(), data.fld, data.da,
                                    forceScale);
                setVisible(false);
            } catch (java.lang.NumberFormatException ex) {
                // wrong number for forceScale
                JOptionPane.showMessageDialog(this, "This is not a number", "Error", JOptionPane.ERROR_MESSAGE);
                forceScaleTF.requestFocus();
                forceScaleTF.selectAll();
            } catch (NegativeScaleException ex) {
                JOptionPane.showMessageDialog(this, "Scale must be non-negative", "Error", JOptionPane.ERROR_MESSAGE);
                forceScaleTF.requestFocus();
                forceScaleTF.selectAll();
            }
        }
    }//GEN-LAST:event_okButtonActionPerformed

    private void forceScaleTFaddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_forceScaleTFaddButtonActionPerformed
        // please, DO NOT add any lines here, instead edit _okButtonActionPerformed()
        // it's a workaround, because Netbeans doesn't allow changing visibility of action handler :/
        _okButtonActionPerformed();
    }//GEN-LAST:event_forceScaleTFaddButtonActionPerformed
     // Variables declaration - do not modify//GEN-BEGIN:variables

    private javax.swing.JButton cancelButton;
    private javax.swing.JList dataCB;
    private javax.swing.JTextField forceScaleTF;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables
}
//revised.
